#include <cvequid.h>
#include <fortran_common.h>
int cvequid(WEJSCIE *in, WYJSCIE *out)
{
   int i,j,k,kod_powrotu;
   char liczba[3];

//   printf("%s %5d\n","CVEQUID",in->liczba_stalych);
   uni_.mm=in->liczba_stalych;         //przeslanie danych C->Fortran
//   printf("%s %5d\n","CVEQUID",uni_.mm);
   uni_.nexp=in->liczba_miareczkowan;
   u1_.sigemf=in->odchylenie_SEM;
   u1_.sigmav=in->odchylenie_objetosci;
   for (i=0;i<uni_.nexp;i++) {
     c6_.npint[i]=in->liczba_punktow_w_miareczkowaniach[i];
     c6_.vm[i]=in->objetosci_titranda[i];
     u1_.est[i]=in->elektroda_E0[i];
     u1_.alfa[i]=in->elektroda_nachylenie[i];
     add2_.stdest[i]=in->odchylenia_elektroda_E0[i];
     add2_.stdalf[i]=in->odchylenia_elektroda_nachylenie[i];
     add2_.stdvm[i]=in->odchylenia_objetosci_titranda[i];
   }
//   printf("Przypisywanie SEM i V\n");
   k=0;
   for (i=0;i<uni_.nexp;i++) 
   {
//      printf("Miareczkowanie %5d%5d%5d\n",i+1,in->liczba_punktow_w_miareczkowaniach[i],c6_.npint[i]);
      for (j=0;j<c6_.npint[i];j++) 
      {
         c9_.v[k]=in->objetosc[j][i];
	 c16_.emf[k]=in->SEM[j][i];
	 c2_.dev[k]=0.0;
//	 printf("%5d%5d%5d%5d%10.2f%10.2f\n",i,j,k,c6_.npint[i],c9_.v[k],c16_.emf[k]);
	 k++;
      }
   }
//   printf("Koniec przypisywania SEM i V\n");
   for (i=0;i<uni_.mm;i++) {
     c17_.lk[i]=in->log_stalych_kwasowosci[i];
   };
   c17_.lk[uni_.mm]=-14.0; // -pKw 
//   printf("pkw %10.5f\n",c17_.lk[uni_.mm]); 

   uni_.m=uni_.mm+1;
   uni_.n=uni_.m+2;
   uni_.nrede=0;
   uni_.nstode=0;
   uni_.nspek=0;
//   printf("%s\n","babbbbb");
/* Przypisywanie macierzy stechiometrycznej dla ukladu m rownowag kwasowo-zasadowych
 * oraz reakcji autoprotolizy wody. Ten fragment mozna bedzie wymienic na parsowanie
 * chemicznego zapisu reakcji zachodzacych w ukladzie */
   for (i=0;i<uni_.m;i++) 
   {
     for (j=0;j<uni_.n;j++) 
     {
        c16_.a[j][i]=0.0;
     }
   }
   for (i=0;i<uni_.mm;i++) 
   {
/* i+1-sza reakcja czastkowej dysocjacji kwasu */
     c16_.a[0][i]=1.0; // proton
     c16_.a[i+1][i]=-1.0; // H(mm-i)A
     c16_.a[i+2][i]=1.0; // H(mm-i-1)A
   }
   c16_.a[0][uni_.m-1]=1.0;  // reakcja autoprotolizy wody; proton
   c16_.a[uni_.n-1][uni_.m-1]=1.0;  // ostatni element macierzy dla jonu wodorotlenowego
//   printf("Macierz A przypisana w C\n");
   for (i=0;i<uni_.m;i++) {
	   for (j=0;j<uni_.n;j++) {
		   // printf("%5.1f",c16_.a[j][i]);
           }
//	   printf("\n");
   }
//   printf("%s\n","3babbbbb");

/* 
 * Stezenia w roztworze miareczkowanym i miareczkujacym 
 */
   uni_.ncomp=2;
//      printf("Miareczkowanie %d stezenie kwasu %10.6f stezenie zasady %10.6f\n",i,in->stezenie_kwasu[i-1],in->stezenie_zasady[i-1]);
   if (in->nadmiar_kwasu==0 && in->zanieczyszczenie_kwasu==0) {
      printf("%d %10.5f %10.5f buuum1\n",i,in->nadmiar_kwasu,in->zanieczyszczenie_kwasu);
      c23_.nnz[0]=1;
      c23_.nnz[1]=1;
      c23_.wy[0][0]=2;
      c23_.wy[0][1]=uni_.n;
      c24_.qcomp[0][0]=in->stezenie_kwasu;
      c24_.qcomp[0][1]=in->stezenie_zasady;
      c22_.nvar[0]=0;
      c22_.nvar[0]=0;
   } else {
      printf("%d %10.5f %10.5f buuum2\n",i,in->nadmiar_kwasu,in->zanieczyszczenie_kwasu);
      c23_.nnz[0]=2;
      c23_.nnz[1]=1;
      c23_.wy[0][0]=1;
      c23_.wy[1][0]=2;
      c23_.wy[0][1]=uni_.n;
      c24_.qcomp[0][0]=in->nadmiar_kwasu;
      c24_.qcomp[1][0]=in->stezenie_kwasu;
      c24_.qcomp[0][1]=in->stezenie_zasady;
      if (in->zanieczyszczenie_kwasu==0) {
	  c22_.nvar[0]=0;
	  c22_.nvar[1]=0;
      } else {
	  c22_.nvar[0]=1;
	  c22_.nvar[1]=0;
	  add1_.comdev[0][0]=in->zanieczyszczenie_kwasu;
      }
   }	
   printf("liczba roztworow %d liczba pipetowan %d\n",in->liczba_roztworow,in->liczba_pipetowan);
   add1_.nsolfin=in->liczba_roztworow;
   for (i=0;i<in->liczba_roztworow;i++) {
      add1_.vsolfin[i]=in->objetosci_roztworow[i];
      add1_.stdsolfin[i]=in->odchylenia_objetosci_roztworow[i];
   }
   add1_.nconnect=in->liczba_pipetowan;
   for (i=0;i<in->liczba_pipetowan;i++) {
      add1_.iconnect[i][0]=in->pipetowanie_skad_dokad[i][0];
      add1_.iconnect[i][1]=in->pipetowanie_skad_dokad[i][1];
      add1_.pipeta[i]=in->objetosci_pipetowan[i];
      add1_.stdpipeta[i]=in->odchylenia_objetosci_pipetowan[i];
   }
   for (i=0;i<uni_.nexp;i++) {
      c23_.ncm[i]=2*i+3;
      c23_.nct[i]=2*i+4;
   }
//   printf("Numery reagentow i stezenia\n");
   for (i=0;i<uni_.ncomp;i++) {
//	   printf("%5d%5d%10.5f\n",i,c23_.wy[0][i],c24_.qcomp[0][i]);
   }
/*
 * wspolczynniki w rownaniu Nernsta
 */
   c13_.enrnst[0]=1.0;
   for (i=1;i<uni_.n;i++) {
      c13_.enrnst[i]=0.0;
   }
   for(i=0;i<uni_.n;i++) {
//	   printf("%5.1f",c13_.enrnst[i]);
   }
//   printf("\n");
/*
 * Nazwy reagentow
*/
   for (i=0;i<=uni_.n;i++) {
	   for (j=0;j<32;j++) {
		   strcpy(names_.name[i]," ");
	   }
   }
   for (i=0;i<=uni_.m;i++) {
     strcpy(names_.name[i],"H");
   };
   for (i=1;i<=uni_.mm;i++) {
      if (uni_.mm-i+1>1) {
      sprintf(liczba,"H%1dA",uni_.mm-i+1);
      } else {
	      sprintf(liczba,"HA");
      }
//      printf("%s\n",liczba);
      strcpy(names_.name[i],liczba);
   }
   strcpy(names_.name[uni_.mm+1],"A");
   strcpy(names_.name[uni_.m+1],"OH-");
/* 
 * Wywolanie CVEQUIDu; kod_powrotu=0 wskazuje, ze program zakonczyl sie poprawnie 
 */
//   for(i=0;i<uni_.n;i++) {
//	   printf("%5.1f",c13_.enrnst[i]);
//   }
//   printf("\n");
//    for (i=0;i<in->liczba_miareczkowan;i++) {
//       printf("Miareczkowanie %d\n",i+1);
//       for (j=0;j<in->liczba_punktow_w_miareczkowaniach[i];j++) {
//	  printf("%5d%10.2f%10.2f\n",j+1,in->objetosc[j][i],in->SEM[j][i]);
//       }
//    }
   printf("%s\n","Calling fortran_cvequid");
   fortran_cvequid__(&kod_powrotu); 
   for (i=0;i<uni_.mm;i++) {
	   out->logarytmy_wyznaczonych_stalych[i]=c17_.lk[i]/u1_.blog;
	   out->odchylenia_standardowe_logarytmow_stalych[i]=add3_.stde[i]/u1_.blog;
   }
   k=0;
   for (i=0;i<in->liczba_miareczkowan;i++) {
      for (j=0;j<in->liczba_punktow_w_miareczkowaniach[i];j++) {
         out->teoretyczne_objetosci_titranta[j][i]=in->objetosc[j][i]-c2_.dev[k];
         out->teoretyczne_SEM[j][i]=in->SEM[j][i]-c2_.demf[k];
	 k++;
      }
   }
   return(kod_powrotu);          //np. ilosc wyznaczonych wartosci pKa
}
